Bug 154618 - Review request: wxGTK 2.6.x update
Review request: wxGTK 2.6.x update
Product: Fedora
Classification: Fedora
Component: wxGTK (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Matthew Miller
Fedora Extras Quality Assurance
: FutureFeature
: 159511 162692 (view as bug list)
Depends On: 175500
Blocks: 148958 FE5Target 163440
  Show dependency treegraph
Reported: 2005-04-12 22:42 EDT by Matthew Miller
Modified: 2007-11-30 17:11 EST (History)
11 users (show)

See Also:
Fixed In Version: wxGTK-2.6.3-
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2006-04-18 22:40:46 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
proposed new wxGTK.spec ideas (6.18 KB, text/plain)
2005-04-12 22:42 EDT, Matthew Miller
no flags Details
updated updated wxGTK.spec (6.69 KB, text/plain)
2005-04-13 11:41 EDT, Matthew Miller
no flags Details
updated, updated updated wxGTK.spec :) (6.87 KB, text/plain)
2005-04-13 17:27 EDT, Matthew Miller
no flags Details
proposed updated wxGTK.spec (6.87 KB, text/plain)
2005-04-13 17:42 EDT, Matthew Miller
no flags Details
proposed wxGTK.spec for 2.6.0 (7.03 KB, text/plain)
2005-04-27 17:32 EDT, Matthew Miller
no flags Details
correct proposed wxGTK.spec for 2.6.0 (7.19 KB, text/plain)
2005-04-27 18:16 EDT, Matthew Miller
no flags Details
updated to 2.6.1 (9.98 KB, text/plain)
2005-07-14 13:10 EDT, Matthew Miller
no flags Details
Updated spec file (10.49 KB, text/plain)
2005-10-04 22:08 EDT, Toshio Kuratomi
no flags Details

  None (edit)
Description Matthew Miller 2005-04-12 22:42:49 EDT
The current wxGTK builds an astonishing number of subpackages, and builds
against both GTK+ (1.2) and gtk2 (2.4), which is messy in and of itself
(although done for good reason originally).

The README-GTK for the 2.5.5 development version says:

   wxWidgets no longer supports GTK 1.0.x (as did some early
   snapshots) and support for GTK 1.2.x will be phased out
   over time. Nearly all work is now done on GTK 2.0.x and
   quite a few of the enhancements of GTK+ 2.2.x and even
   GTK 2.4.x are used.

wxWidgets 2.6 is supposed to be released Really Soon Now. Whenever we update to
that version might be a very good time to do some cleanup in this package. The
above paragraph convinces me of what I was already thinking -- we should drop
GTK+ 1.2 support from the package, and just build the GTK2 part.

Plus, while I can see not wanting the gl subpackage to avoid 3D requirements,
the xrc and stc subpackages don't seem to introduce any extra dependencies and
they're only a couple of hundred K each. Unless I'm missing something (I might
be) it seems like these could be just merged into the main package.

So, attaching a modified specfile (based on your existing one -- I cleared out
the changelog, but not to discredit your work or anything -- obviously that
should go back in the real one.)

Hope this is helpful.
Comment 1 Matthew Miller 2005-04-12 22:42:49 EDT
Created attachment 113076 [details]
proposed new wxGTK.spec ideas
Comment 2 Michael Schwendt 2005-04-13 09:17:30 EDT
I find the high number of Obsoletes/Provides/Requires confusing. Here's the
rationale, one by one:

> Requires:       %{name}-common = %{version}-%{release}

Here you require wxGTK-common, but a few lines below you:

> Obsoletes:      wxGTK-common < 2.5.4
> Provides:       wxGTK-common

Effectively, the package requires itself via a versioned dependency on a
non-versioned "Provides". The "Requires" is not needed and wrong.


> # provides generic-name
> Provides:       wxWidgets

> Provides:       wxWidgets-devel

This looks wrong. The goal of a generic name--a virtual capability--is that
*any* package, which "provides" it, is sufficient. But, for instance, you could
not "Buildrequires: wxWidgets-devel" if multiple packages did "Provides:
wxWidgets-devel". Hence the concept behind this generic name is doubtful.


> # all of these are for previous Fedora Extras sub-packages
> Obsoletes:      wxGTK2 < 2.5.4
> Provides:       wxGTK2

The version here and in all the other Obsoletes is too low. In wxGTK = 2.5.5,
you would need to either

  Obsoletes: wxGTK2 < 2.5.5


  Obsoletes: wxGTK2 <= 2.5.4

so any 2.5.4 package would be obsoleted, too, and

  Provides: wxGTK2 = %version-%release

as else you could not reintroduce wxGTK2 > %version-%release without increased
package update efforts. Same for all other pairs of Obsoletes/Provides. The
Provides ought to be versioned:

  Obsoletes: oldname < %version-%release
  Provides: oldname = %version-%release
Comment 3 Matthew Miller 2005-04-13 11:40:21 EDT
The first one is a mistake, which I just noticed myself.

The second: why couldn't you "Buildrequires: wxWidgets-devel" if multiple
packages  provide it? I'm not particularly attached this one, though.

The third: yep. The 2.5.4s are a result of not looking carefully enough when
updating to the new version. I thought I had a good reason for not using
%version when I first made it, but I can't think of it now.

Thanks for the feedback -- here's a version fixing the first and third issue.
Comment 4 Matthew Miller 2005-04-13 11:41:56 EDT
Created attachment 113103 [details]
updated updated wxGTK.spec
Comment 5 Michael Schwendt 2005-04-13 13:03:54 EDT
Assume we have wxGTK-devel and wxMotif-devel and both "Provides:
wxWidgets-devel". Which one would a package with "Buildrequires:
wxWidgets-devel" build against?

Obviously the specific one it is set up to support. If the package picked up a
generic wxWidgets implementation (which would be possible with an API framework
like wxWidgets), the build would not be reproducible.

Hence the purpose of a generic wxWidgets and wxWidgets-devel is doubtful. The
individual implementations of wxWidgets are not interchangeable. Only the
wxWidgets API is the same, the ABI of the individual ports is not.
Comment 6 Matthew Miller 2005-04-13 17:28:07 EDT
Created attachment 113124 [details]
updated, updated updated wxGTK.spec :)

Okay, I can buy that. I guess I had just assumed that they'd be ABI compatible
without looking or thinking about it hard enough. :)

Thanks again for looking at this.
Comment 7 Matthew Miller 2005-04-13 17:42:59 EDT
Created attachment 113125 [details]
proposed updated wxGTK.spec

(sorry, forgot to actually increase the release number in that one.)
Comment 8 Matthew Miller 2005-04-27 17:32:59 EDT
Created attachment 113745 [details]
proposed wxGTK.spec for 2.6.0

wxWidgets 2.6.0 is out. Here's the updated spec file -- only minor changes.
Comment 9 Matthew Miller 2005-04-27 17:42:23 EDT
Wait, there's a problem with that one -- sorry, jumping the gun. Fixed update
coming soon. :)
Comment 10 Matthew Miller 2005-04-27 18:16:02 EDT
Created attachment 113746 [details]
correct proposed wxGTK.spec for 2.6.0
Comment 11 Matthew Miller 2005-04-29 23:30:25 EDT
PS: I have no strong opinion about whether the package should be called wxGTK as
in the spec file attached to this bug or wxGTK2 to match wxPythonGTK2 (and the
gtk2 package itself). The main suggestion is dropping the complication required
by including both old gtk+ 1.x and gtk2 support. (And also consolidating the
Comment 12 Michael Schwendt 2005-07-07 16:09:44 EDT
*** Bug 162692 has been marked as a duplicate of this bug. ***
Comment 13 Matthew Miller 2005-07-14 12:02:32 EDT
Note that this fixes bug #159511 -- wxrc is correctly in the devel package.
Comment 14 Matthew Miller 2005-07-14 13:10:39 EDT
Created attachment 116759 [details]
updated to 2.6.1

* Thu Jul 14 2005 Matthew Miller <mattdm@mattdm.org> - 2.6.1-0.1
- update to 2.6.1
- from Michael Schwendt in 2.4.2-11 package: build-require
  xorg-x11-Mesa-libGL and xorg-x11-Mesa-libGLU (the libGL and libGLU
  deps aren't provided in FC3, so not using that).
- from Thorsten Leemhuis in 2.4.2-12 package: sed -i -e
  's|/usr/lib\b|%%{_libdir}|' in configure also to fix x86_64
- properly include older 2.4.x changelog
Comment 15 Matthew Miller 2005-07-14 13:12:13 EDT
Notes on 2.6.1-0.1 package: haven't tested with gcc4 or on FC4 yet; will do that
soon. Also, only tested on i386.
Comment 16 Miloš Komarčević 2005-08-18 04:38:10 EDT
I assume the new packages will come with unicode support enabled?

I tried compiling poEdit to use for localizing Fedora, but it's a no go with
current wxGTK2 packages.
Comment 17 Matthew Miller 2005-08-18 07:56:00 EDT
Yes, the proposed spec file has --enable-unicode.
Comment 18 Michael Schwendt 2005-08-18 16:22:37 EDT
So, since wxGTK in Extras is officially "orphaned", we need a different

Do we have a volunteer package maintainer? Matthew?

In case we don't, how about the following? Create an ordinary CVS-style
branch in Extras CVS where we check in the proposed changes, and then
continue from there. Thoughts?
Comment 19 Matthew Miller 2005-08-18 17:51:25 EDT
I can take official responsibility for it. But I have Death Plague Cough right
now (it's going around at work) so it may be a few days before I gather my
strength to do it. :)
Comment 20 Warren Togami 2005-08-18 17:53:59 EDT
/me fears impending move to Boston area.
Comment 21 Matthew Miller 2005-08-18 18:15:40 EDT
Oh, it's great! A few Death Plagues a year builds character.
Comment 22 Tom "spot" Callaway 2005-08-29 08:58:31 EDT
wxPython 2.6 wants us to also run:

make %{?_smp_mflags} -C contrib/src/animate
%makeinstall -C contrib/src/animate

(this adds /usr/lib/libwx_gtk2u_animate-2.6.so.0
/usr/lib/libwx_gtk2u_animate-2.6.so.0.0.0 and /usr/lib/libwx_gtk2u_animate-2.6.so)

Comment 23 Matthew Miller 2005-08-29 09:07:02 EDT
I can add that.
Comment 24 Paul F. Johnson 2005-08-29 17:43:21 EDT
License:        wxWindows Library Licence

I think that this should be changed to wxWidgets prior to the OSI approval of
the licence - simple reason is down to the amount of grief the wx people had
from a certain company.
Comment 25 Paul F. Johnson 2005-08-29 17:49:03 EDT
Release:        0.1

Should really be

Release:        0.1%{?dist}

(little thing)
Comment 26 Tom "spot" Callaway 2005-09-14 15:36:01 EDT
We need to go ahead and bite the bullet on this. I'm willing to maintain the old
compat-wxGTK and compat-wxPython 2.4 bits.
Comment 27 Matthew Miller 2005-09-14 15:46:12 EDT
Sorry I've been out of touch -- 8 month old child + start of school year at work
= crazy. Will work on this RSN, for real.
Comment 28 Toshio Kuratomi 2005-10-04 22:08:13 EDT
Created attachment 119633 [details]
Updated spec file

Here's an update of Matthew's spec file.
- Update to 2.6.2.
- Include the sample wx bakefiles.
- Include new .mo files.
- From Paul Johnson:
  Change license to wxWidgets due to concerns over trademark infringement.
  Add dist tag.
- From Tom Callaway: Build and include libwx_gtk2u_animate-2.6.

I'm not prepared to take on this package but I hope this can help you, Matthew,
catch up.  I'm hoping to see a pgadmin that's useful for the present postgresql
so I thought I'd give a little help here.

SPEC and SRPM in:
Comment 29 Matthew Miller 2005-10-04 22:11:13 EDT
Thank you very much. This is still large on my radar but I've continued to be
Comment 30 Paul F. Johnson 2005-10-18 05:55:55 EDT
Is there any sign of movement on this? I have a couple of packages waiting for
submission which need wx2.6
Comment 31 Matthew Miller 2005-10-20 10:26:28 EDT
Will work on it this weekend. Need to get myself caught up on current FE
procedures. Sorry again for the delay.
Comment 32 Paul F. Johnson 2005-10-22 14:57:01 EDT
Minor change to the spec at http://www.tiki-lounge.com/~toshio/fedora/ - there
is a small remarked piece about wxWindows and OSI licence. From what I gather,
it's now been okayed.

Currently building it - looks fine.
Comment 33 Matthew Miller 2005-10-23 16:14:52 EDT
Yes, looks good to me too -- thanks, Toshio. Since this isn't a new package, but
a new maintainer, should this go through further review, or should I go ahead
and check it in?
Comment 34 Ville Skyttä 2005-11-04 16:33:05 EST
Test-built on FC4, and seems otherwise ok, but shouldn't the BR be  
libgnomeprintui22-devel, not libgnomeprint22-devel?  
Comment 35 Matthew Miller 2005-11-04 16:36:03 EST
Possibly. :)
Comment 36 Matthias Saou 2005-11-28 07:05:50 EST
That last spec file will need to be updated slightly for the new modular X.

I'd really like to see this update out ASAP, as many recent releases of projects
using wxWindows fail to build against the current 2.4.x packages (VLC, xMule).

Minor suggestions :
- %setup -q -n %{name}-%{version} : -n not needed
- %{summary}. as %description should be avoided. Spec file grammar doesn't say
  if it'll be the main or the sub-package summary.
- export CC and CXX are useless, add a comment to the spec otherwise.
- same for export CFLAGS and CXXFLAGS, as %configure is used and sets them
- %dir %{_libdir}/wx should be part of the devel sub-package, not the main
Comment 37 Matthew Miller 2005-11-28 07:38:13 EST
Matthias -- thanks. The modular update suggestion was already done; see

I'll include your other ones too. Any suggestions on the wxPython packages
there, by the way?
Comment 38 Matthias Saou 2005-11-28 08:22:36 EST
I just tried rebuilding wxGTK 2.6.2 on FC4 and got :
/usr/bin/ld: cannot find -lwxregexu-2.6
That lib didn't get compiled, although configure wrote :
checking for glibc 2.1 or later... yes
configure: WARNING: Defaulting to the the builtin regex library for Unicode
  Which libraries should wxWidgets use?
                                       jpeg               sys
                                       png                sys
                                       regex              builtin
                                       tiff               sys
                                       zlib               sys

Possibly a bug in 2.6.2.
Has anyone recompiled it successfuly on FC4?
Comment 39 Matthew Miller 2005-11-28 08:48:27 EST
Hmmm. I'm only intending to target this for FC5, since it's such a big jump. We
should, however, find out why it's failing and add the proper buildrequires.

I don't have a handy FC4 test machine though....
Comment 40 Matthias Saou 2005-11-28 09:59:26 EST
I found the problem : A leftover "\" at the end of the last configure option, so
the make command was being appended on the same line, because I had removed the
empty line between the two sections (from Toshio's 2.6.2 spec file, still in
yours). Please fix, it bites! ;-)

From there, VLC and xMule rebuild fine. I'll test aMule and Audacity, and
probably push this 2.6 package into freshrpms.net for FC4... as the benefit for
users who have enabled the freshrpms.net repository seems worth the minor
breakage it'll cause with Extras packages depending on some older wxGTK.
Comment 41 Tom "spot" Callaway 2005-11-28 10:25:46 EST

Why not just push it into extras for FC-4 and 5? I've got those "compat-"
packages ready to go, we will very quickly see which packages need the compat-*
versions in order to rebuild, and I can patch them up easily.
Comment 42 Matthias Saou 2005-11-28 10:39:51 EST
I'm all for pushing 2.6 to Extras FC4 & FC5, with the appropriate compat-*
packages (I think that a single one based on the current FC4 2.4 package would
be enough, since it contains both gtk1 and gtk2 libs).

Matthew, are you going to be the new wxGTK owner? If so, please update
owners.list, and if no one objects, go ahead and do the update, having Spot
introduce the compat package at the same time (or shortly after, since things
should get held back in a non-breaking matter anyway).

Here are the packages that might need a rebuild (if ever we just want to avoid
the whole compat approach, might be doable as there aren't that many) :

$ for file in *.i386.rpm; do rpm --nogpg -qp --requires $file | grep libwx
>/dev/null && echo $file; done

In addition to these, I've got VLC, aMule and xMule, which all build fine with
2.6, so I won't be needing the compat package for freshrpms.
Comment 43 Tom "spot" Callaway 2005-11-28 11:18:07 EST
wxPythonGTK2 needs to be bumped to 2.6 at the same time as wxGTK2 (but I see
Matthias has a package for that too).

Audacity, Bochs, comical, and scorched3d won't work with unicode enabled wxGTK,
gentoo works around this issue by building both the unicode and the non-unicode
wxGTK libs and config. Then, they patch applications to call $WX_CONFIG instead
of wx-config, and set WX_CONFIG=wx-gtk2-unicode-config or
WX_CONFIG=wx-gtk2-config as needed.

pgadmin3 needs the stc package, which is only found in 2.4.
Comment 44 Matthew Miller 2005-11-28 12:27:16 EST
Matthias -- updated with your suggestions / fixes at

Spot -- Yeah, I have wxPython packages too. The current audacity won't work with
the new wxGTK, but the CVS version will *only* work with the new one.

I'm not terribly keen on building both versions of the library; seems like the
applications ought to get fixed. (Maybe build them against your compat packages
in the meantime?)

Also, wxPython 2.6.2.x isn't out yet, causing it to spit out a warning at
runtime when built against this version. Ugly.
Comment 45 Matthias Saou 2005-11-28 13:22:01 EST
OK, the last thing I haven't mentionned about the spec file are the
obsoletes : I find it smarter to hardcode the version when the obsoletes
happened instead of putting the "dynamic" %{version}-%{release}.

For instance :
Obsoletes:      wxGTK2 < %{version}-%{release}
Would be replaced by :
Obsoletes:      wxGTK2 < 2.6.2-1

That way you have a fixed limit on what you're obsoleting, which is
IMHO a good thing.
Comment 46 Matthew Miller 2005-11-28 15:49:41 EST
Okay, this is done and in tree. (Without Matthias's latest change -- I'll
remember that for next time I do an update, though.)

On to wxPython....

Spot, you wanna add the compat package now?
Comment 47 Matthias Saou 2005-11-30 08:09:22 EST
FYI, I've gotten a bunch of reports from this morning about aMule crashing
for some users with this wxGTK 2.6.2. One pointed me to this bug report :


Which includes a patch to fix the issue. I guess I didn't notice the problem
since I use the default en_US or C pretty much everywhere.

This definitely needs to be included in the 2.6.2 packages before they're
pushed out for FC-4.
Comment 48 Matthew Miller 2005-11-30 16:08:31 EST
Matthias -- thanks, working on that now. Any comments on the wxPython packages?
(should go in bug #163440)
Comment 49 Matthias Saou 2005-12-01 06:04:07 EST
I don't have anything to actually test wxPython with, so all I'll do is a quick
review of the spec, but no deeper testing.
Spot: Got those compat-* libs ready? Time to roll out wxGTK 2.6? With the above
patch, it's working great with aMule and VLC.

For audacity, which was mentioned, the 1.3.0 (beta) works great for me with
wxGTK 2.6.2 too. You can find my spec file and patches here :
(quite a few workarounds are needed)
Might be a good candidate for Extras devel.
Comment 50 Gérard Milmeister 2005-12-05 12:36:32 EST
Is there not going to be 2.6.2 for FC4? If not, then someone else
must take over the task of building audacity (1.3.0) for devel.
Comment 51 Tom "spot" Callaway 2005-12-05 12:42:46 EST
I think that the holdup is actually on me at this point to push the compat
packages into Extras.

I'll start that review process this week.
Comment 52 Tom "spot" Callaway 2005-12-11 18:54:19 EST
Compat packages are pending review at 175500.
Comment 53 Nicola Soranzo 2006-01-04 09:42:47 EST
What about adding support for databases? This needs --with-odbc in configure,
adding additional BuildRequires and Requires, maybe creating a specific subpackage.
Comment 54 Matthew Miller 2006-01-04 10:21:26 EST
Nicola -- please file a separate bug request for that. Thanks.
Comment 55 Nicola Soranzo 2006-01-04 12:18:30 EST
(In reply to comment #54)
> Nicola -- please file a separate bug request for that. Thanks.

Ok, see bug 176950.
Comment 56 Tom "spot" Callaway 2006-01-06 11:43:28 EST
Turns out I actually need wxGTK 2.6 in FC-4 for comical, as the most recent
versions don't build with 2.4.2. I see 2.6 in devel, are we still holding on it
in FC-4 for this patch:


I'd like to see it go in, now that the compat-* packages are in as well.
Comment 57 Matthew Miller 2006-01-06 12:02:56 EST

Wife and baby going out of town next week -- ideal time to get this wrapped up. :)
Comment 58 Alex Lancaster 2006-01-20 04:14:16 EST
Has that patch gone in would be nice to test wxWidgets 2.6 on FC-4.  I would
like to test the musicbrainz tagger, picard, which requires wxPython 2.6:

Comment 59 Matthew Miller 2006-02-06 12:54:58 EST
Okay, working on the final touches here.

To my joy, the current package now doesn't build on FC5-rawhide. *sigh*.
Comment 60 Matthias Saou 2006-02-24 11:20:34 EST
Hey, still no news about pushing the 2.6 update to FC-4?
Comment 61 Matthew Miller 2006-02-24 11:24:07 EST
I want to get the wxPython thing sorted out first. Sorry it's all taking so long.
Comment 62 Matthew Miller 2006-03-14 21:27:06 EST
wxGTK 2.6.3 should be out any day now. That will resolve the wxPython issue,
allowing bug #163440 to go forward, and at that point I'll push this back to
FC4. Just in time for FC5. :)
Comment 63 Matthias Saou 2006-03-15 05:11:37 EST
At last, great! Please let us know as soon as wxGTK 2.6.3 goes into FC5 Extras
and FC4 Extras, as I'll have some cleaning up and rebuilding to do.
Comment 64 Alex Lancaster 2006-03-30 02:23:49 EST

Looks like wxwidgets.org 2.6.3 is out (as well as wxPython
Comment 65 Matthew Miller 2006-03-30 06:44:34 EST
Buildsystem has been broken. wxGTK package has been ready to go for days. I'll
try again right now.
Comment 66 Alex Lancaster 2006-04-04 15:14:06 EDT
Looks like devel has succeeded, so 'bout those FC-4 & FC-5 builds?
Comment 67 Matthew Miller 2006-04-04 15:40:02 EDT
Sorry for the lack of communication -- I'm overbooked. :) There's a couple of
patches that need to go in before the FC4/5 ones go out.
Comment 68 Matthew Miller 2006-04-13 17:09:46 EDT
*** Bug 159511 has been marked as a duplicate of this bug. ***
Comment 69 Matthew Miller 2006-04-18 22:40:46 EDT
Okay. This is building in FC4 and should be available soon. If that turns out to
be All Horribly Broken, please reopen this. For other issues, file new, specific
bugs. Thanks!

Note You need to log in before you can comment on or make changes to this bug.